#include <iostream>
using namespace std;
template <class Type>
unsigned int smallest(Type Array, unsigned int size){
    int min = 0;
    for(int i = 1; i < size; i++)
        if(Array[i] < Array[min]) 
            min = i;
    return min;
}
template <class ArrayType>
class TempArray{
    const int ArraySize;
    ArrayType *array;
    public:
        TempArray(int size) : ArraySize(size){
            array = new ArrayType[ArraySize];
        }
        ArrayType &operator[](unsigned int);
};
template <class ArrayType>
ArrayType &TempArray<ArrayType>::operator[](unsigned int element){
    return array[element];
}
class Binary{
    int size;
    int *value;
    public:
        Binary(int sz = 0):size(sz){
            value = new int [size];
            for(int i = 0; i < size; i++){
                cout <<  "Most Significant " << i+1 << ". Digit : " ;
                cin >> value[i];
            }
        }
        int Calculate() const{
            int rValue = 0;
            for(int i = 0; i < size; i++)
                rValue = rValue * 2 + value[i];
            return rValue; 
        }
        bool operator<(Binary &in){
            if(Calculate() < in.Calculate())
                return true;
            return false;
        }
        void operator=(Binary const &in){
            size = in.size;
            delete [] value;
            value = new int[size];
            for(int i = 0; i < size; i++)
                value[i] = in.value[i];
        }
        ~Binary(){
            delete [] value;
        }
};
ostream& operator <<(ostream& out, const Binary& in){
	out << in.Calculate() << endl;
    return out;
}
int main(void){
    int inta[]={1, -7, 0, 3};
    unsigned int smallest_i = smallest(inta, 4);
    cout << "Smallest element is : " << inta[smallest_i] << endl;
    TempArray<int> intArr(5);
        intArr[0] = 1;
        intArr[1] = -5;
        intArr[2] = 8;
    smallest_i = smallest(intArr, 3);
    cout << "Smallest element is : " << intArr[smallest_i] << endl;
    TempArray<Binary> binArr(3);
        Binary b1(3), b2(2);
        binArr[0] = b1;
        binArr[1] = b2;
    smallest_i = smallest(binArr, 2);
    cout << binArr[smallest_i];
    system("PAUSE");
    return 1;
}
